<?php
/**
 * Copyright (c) 2022-2222   All rights reserved.
 *
 * 创建时间：2022-04-03 10:38
 *
 * 项目：levs  -  $  - AdminQuickNavController.php
 *
 * 作者：liwei
 */

//!defined('INLEV') && exit('Access Denied LEV');


namespace modules\levs\controllers;

use Lev;
use lev\base\Adminv;
use lev\base\Assetsv;
use lev\base\Controllerv;
use modules\levs\helpers\levsCacheFileHelper;
use modules\levs\widgets\admin_quick_nav\tabViewAdminQuickNavWidget;

Adminv::checkAccess();
Assetsv::registerSuperman();

class AdminQuickNavController extends Controllerv
{

    public static function actionIndex() {
        $tabId = Lev::stripTags(Lev::GPv('tab') ?: Lev::GPv('opid'));

        tabViewAdminQuickNavWidget::viewvs($tabId);
    }

    public static function actionLoadData() {
        $tabId = Lev::stripTags(Lev::GPv('tab') ?: Lev::GPv('opid'));

        $responseMsg = tabViewAdminQuickNavWidget::loadData($tabId);
        //Lev::showMessages($responseMsg);
        static::echoJson($responseMsg);
    }

    public static function actionAdd() {
        $del = Lev::GPv('del');
        $iden = Lev::stripTags(Lev::GPv('iden'));
        $navid = Lev::stripTags(Lev::GPv('navid'));
        $navtype = Lev::stripTags(Lev::GPv('navtype'));
        $key = $iden.'_'.$navtype.'_'.$navid;
        $val = [
            'iden' => $iden,
            'navid' => $navid,
            'navtype' => $navtype,
        ];
        $del ? levsCacheFileHelper::delAdminQuickNavs($key) : levsCacheFileHelper::joinAdminQuickNavs($val, $key);
        static::echoJson(Lev::responseMsg());
    }
}