<?php
/* 
 * Copyright (c) 2018-2022   All rights reserved.
 *
 * 创建时间：2022-06-17 12:30:21
 *
 * 项目：/levs  -  $  - AdminUserDetailController.php
 *
 * 作者：{{AUTO GENERATE}}
 */

//此文件使用程序自动生成，下次生成时【不会】覆盖。
//在这里可以补充、完善你的程序逻辑

namespace modules\levs\controllers;

use Lev;
use lev\base\Viewv;
use modules\levs\controllers\_gen\BaseAdminUserDetail;

!defined('INLEV') && exit('Access Denied LEV');

class BaseAdminUserDetailMiddle extends BaseAdminUserDetail
{

    public static function headerHtm()
    {
        //return parent::headerHtm(); // TODO: Change the autogenerated stub
        //return '<tips class="gray inblk scale8">自定义headerHtm：文件位置：'.__DIR__ . '/AdminUserDetailController.php'.'</tips>';
        return Viewv::renderPartial(__DIR__ . '/../template/renders/admin-user-detail/myself/header_htm.php', []);
    }

    public static function footerHtm()
    {
        return parent::footerHtm(); // TODO: Change the autogenerated stub
        //return '<tips class="gray inblk scale8">自定义footerHtm</tips>';
    }

    public static function cardFooterButtons($btns = [])
    {
        return parent::cardFooterButtons($btns); // TODO: Change the autogenerated stub
        //return '<tips class="gray inblk scale8">自定义cardFooterButtons</tips>';
    }

    public static function headerViewHtm()
    {
        return parent::headerViewHtm(); // TODO: Change the autogenerated stub
        //return '<tips class="gray inblk scale8">自定义headerViewHtm：文件位置：'.__DIR__ . '/AdminUserDetailController.php'.'</tips>';
    }

    public static function footerViewHtm()
    {
        return parent::footerViewHtm(); // TODO: Change the autogenerated stub
        //return '<tips class="gray inblk scale8">自定义footerViewHtm</tips>';
    }
}

class AdminUserDetailController extends BaseAdminUserDetailMiddle
{

    public static $tmpPath = 'admin-user-detail';
    public static $trash   = true;//是否允许删除数据
    public static $addurl  = false;//是否显示创建数据按钮
    public static $addRoute = 'Form_lev_users';//自定义创建数据表单地址 - 默认使用源表单

    public static $srhtitle    = '用户名';//模糊搜索字段名称
    public static $srhkeyWhere = 'username LIKE \'%{srhkey}%\'';//模糊搜索sql语句 例：name LIKE '%{srhkey}%'

    public static $limit = 20;//每页显示多少条
    public static $order = ['id DESC'];//排序

    /**
     * 列表显示字段设置
     * 例：array(
    'id'           => array('order' => null, 'name' => 'Id', 'thattr' => 'wd30 nowrap', 'merge' => []),

    'name'         => array('order' => null, 'name' => '模块名称', 'thattr' => 'wd30 nowrap', 'merge' => ['addtime']),

    'displayorder' => array('order' => null, 'name' => '排序', 'thattr' => 'wd30 nowrap', 'merge' => []),

    'uptime'       => array('order' => null, 'name' => '更新时间', 'thattr' => 'wd30 nowrap', 'merge' => []),

    );
     *
     * order: 点击字段排序
     * name: 字段名称
     * thattr: 表格th属性，放class属性内，内容举例：wd30 nowrap" style="font-size:12px
     * merge: 合并显示，多个字段合并显示到一个上
     *
     * @see BaseAdminUserDetail::showColumns();
     */
    public static function showColumns() {
        //return parent::showColumns(); // TODO: Change the autogenerated stub
        return array(
                'id'           => array('order' => null, 'name' => '用户UID', 'thattr' => 'wd30 nowrap', 'merge' => []),

                'username'     => array('order' => null, 'name' => '用户名', 'thattr' => 'wd30 nowrap', 'merge' => []),

                'groupid'      => array('order' => null, 'name' => '用户组ID', 'thattr' => 'wd30 nowrap', 'merge' => []),

                'adminid'      => array('order' => null, 'name' => '管理组ID', 'thattr' => 'wd30 nowrap', 'merge' => []),

                'wxopenid'     => array('order' => null, 'name' => '微信公众号开放ID', 'thattr' => 'wd30 nowrap', 'merge' => []),

                //'baiduopenid'  => array('order' => null, 'name' => '百度小程序开放ID', 'thattr' => 'wd30 nowrap', 'merge' => []),

                'alipayuserid' => array('order' => null, 'name' => '支付宝开放ID', 'thattr' => 'wd30 nowrap', 'merge' => ['baiduopenid']),

                'cnymoney'     => array('order' => null, 'name' => '人民币余额', 'thattr' => 'wd30 nowrap', 'merge' => []),

                'rname'        => array('order' => null, 'name' => '真实姓名', 'thattr' => 'wd30 nowrap', 'merge' => []),

                //'country'      => array('order' => null, 'name' => '国家', 'thattr' => 'wd30 nowrap', 'merge' => []),

                //'prov'         => array('order' => null, 'name' => '省份', 'thattr' => 'wd30 nowrap', 'merge' => []),

                'city'         => array('order' => null, 'name' => '城市', 'thattr' => 'wd30 nowrap', 'merge' => ['country','prov']),

                'cardno'       => array('order' => null, 'name' => '身份证号', 'thattr' => 'wd30 nowrap', 'merge' => []),

                'mobile'       => array('order' => null, 'name' => '手机号', 'thattr' => 'wd30 nowrap', 'merge' => ['email']),

                //'email'        => array('order' => null, 'name' => '邮箱Email', 'thattr' => 'wd30 nowrap', 'merge' => []),

                'qq'           => array('order' => null, 'name' => 'QQ', 'thattr' => 'wd30 nowrap', 'merge' => []),

                //'safepwd'      => array('order' => null, 'name' => '二级安全密码', 'thattr' => 'wd30 nowrap', 'merge' => []),

                'ip'           => array('order' => null, 'name' => 'IP', 'thattr' => 'wd30 nowrap', 'merge' => ['safepwd']),

                //'settings'     => array('order' => null, 'name' => '通用设置', 'thattr' => 'wd30 nowrap', 'merge' => []),

                'status'       => array('order' => null, 'name' => '状态', 'thattr' => 'wd30 nowrap', 'merge' => []),

                'uptime'       => array('order' => 1, 'name' => '更新时间', 'thattr' => 'wd30 nowrap', 'merge' => []),

                //'addtime'      => array('order' => null, 'name' => '添加时间', 'thattr' => 'wd30 nowrap', 'merge' => []),

            );
    }

    /**
     *
     return [
        'showtype' => [
            //从上往下先到先得
            'input_{columnKey}'  => ['width'=>120,'textarea'=>1],//显示为无刷新更改字段
            'srhkey_{columnKey}' => ['or'=>['{columnKey}']],//显示为点击可搜索字段
            'status_{columnKey}' => 1,//显示为开关状态字段 status 自动
            'order_{columnKey}'  => 1,//显示为可排序输入框 含order关键字 自动
            'time_{columnKey}'   => 1,//显示为时间格式字段 含time关键字 自动
        ],
    ];
     *
     * @return array
     */
    public static function setColumnShowtype()
    {
        return parent::setColumnShowtype(); // TODO: Change the autogenerated stub
    }

    public static function formatListsv($sv, $lists)
    {
        $v = $sv;
        $sv = parent::formatListsv($sv, $lists); // TODO: Change the autogenerated stub
        //$sv = levUsersModelHelper::formatListvField($sv, $lists);
        return $sv;
    }

    public static function formatUid($sv, $lists, $srhkey = ['uid'], $username0 = '')
    {
        return parent::formatUid($sv, $lists, $srhkey, $username0); // TODO: Change the autogenerated stub
    }

    public static function redirct($columnKey, $sv)
    {
        return parent::redirct($columnKey, $sv); // TODO: Change the autogenerated stub
    }

    public static function optButtons($sv)
    {
        return parent::optButtons($sv); // TODO: Change the autogenerated stub
    }

    public static function footerBtns($btns = [])
    {
        return parent::footerBtns($btns); // TODO: Change the autogenerated stub
    }

}