<?php
/**
 * Copyright (c) 2022-2222   All rights reserved.
 *
 * 创建时间：2022-11-08 11:16
 *
 * 项目：levs  -  $  - ReceivePushLevUsersController.php
 *
 * 作者：liwei
 */

//!defined('INLEV') && exit('Access Denied LEV');

//此文件使用程序自动生成，下次生成时会覆盖，不建议修改。

namespace modules\levs\controllers\_gen;

use Lev;
use lev\base\Adminv;
use lev\base\Controllerv;
use lev\base\Requestv;
use lev\base\Viewv;
use lev\helpers\curlHelper;

class BaseReceivePush extends Controllerv
{
    public static $dataModel = '\modules\levs\table\lev_users\levUsersModelHelper';
    public static $tabRoute = 'lev-users';

    public static function getDataModelObj() {
        return static::$dataModel;
    }

    public static function actionIndex() {
        $route = Lev::stripTags(Lev::GPv('route'));
        Viewv::renders(__DIR__ . '/../../template/renders/receive-push/index.php', [
            'pushUrl' => Lev::toReRoute(['receive-push-lev-users/push', 'id'=>'levs']),
            'pullUrl' => Lev::toReRoute(['receive-push-lev-users/pull', 'id'=>'levs']),
            'setUrl' => \lev\helpers\UrlHelper::supermanSettings('levs', 'receivePushSet'),
            'pushSites' => static::pushSites(),
            'tips' => '默认识别id进行数据插入，已存在ID不进行数据插入，控制器文件：\modules\levs\controllers\ReceivePushLevUsersController::receiveData()',
            'headerHtm' => static::headerHtm(),
            'domainurl' => str_replace(Lev::$aliases['@siteurl'], '', Lev::toReRoute([$route?:'/', 'id'=>'levs'])),
        ]);
    }

    public static function actionPull() {
        $page = max(intval(Lev::GPv('page')), 1);
        $pageNum = intval(Lev::GPv('pageNum'));
        $limit = intval(Lev::GPv('limit'));
        $doids = Lev::GPv('doids');


        Adminv::isAdmin();

        $msgs = [];
        $sites = static::pushSites();
        foreach ($sites as $v) {
            if (empty($v['status']) && (!$doids || in_array($v['id'], $doids)) && $domain = trim(trim($v['domain']), '/')) {
                $pm['url'] = $domain . '/levs.php?id=levs&r=receive-push-'.static::$tabRoute.'/pull-server&pwd='.$v['pwd'].'&limit='.$limit.'&page='.$page;
                $json = curlHelper::doCurl($pm);
                $msg = json_decode($json, true);
                $msgs[$domain] = $json;
                if (!empty($msg['lists'])) {
                    static::receiveData($msg['lists'], $v['pwd']);
                    $msgs['count'] = count($msg['lists']).'条';
                    break;
                }
            }
        }
        if (Lev::isAjax()) {
            $msgsArr = Lev::responseMsg(1, '');
            $msgsArr['pushRes'] = $msgs;
            if ($page <$pageNum) {
                $msgsArr['nextUrl'] = Lev::toCurrent(['page' => $page + 1]);
            }
            static::echoJson($msgsArr);
        }else {
            Lev::showMessages($msgs);
        }
    }

    public static function actionPush() {
        $page = max(intval(Lev::GPv('page')), 1);
        $pageNum = intval(Lev::GPv('pageNum'));
        $limit = intval(Lev::GPv('limit'));
        $doids = Lev::GPv('doids');
        $pushids = Lev::GPv('pushids');

        Adminv::isAdmin();
        $obj = static::getDataModelObj();
        if ($pushids) {
            $insql = Lev::idInsql($pushids);
            $insql && $lists = $obj::findAll('id IN ('.implode(',', $insql).')');
        }else if ($limit >0) {
            $lists = $obj::pages(1, $limit, ['id DESC']);
        }
        $msg = [];
        if (!empty($lists)) {
            $sites = static::pushSites();
            foreach ($sites as $v) {
                if (empty($v['status']) && (!$doids || in_array($v['id'], $doids)) && $domain = trim(trim($v['domain']), '/')) {
                    if ($limit < 1) {
                        $num = max(intval($v['page']), 1);
                        ($lists === null || $num > count($lists)) &&
                        $lists = $obj::pages(1, $num, ['id DESC']);
                    }
                    $pm['url'] = $domain . '/levs.php?id=levs&r=receive-push-' . static::$tabRoute . '/receive&pwd=' . $v['pwd'];
                    $pm['post'] = ['lists' => $lists];
                    $pm['time'] = 3;
                    $msg[$domain] = curlHelper::doCurlRawBody($pm) ?: '推送失败，或许内存不足';
                }
            }
        }
        if (Lev::isAjax()) {
            $msgs = Lev::responseMsg(1, '');
            $msgs['pushRes'] = $msg;
            if (!isset($insql) && $page <$pageNum) {
                $msgs['nextUrl'] = Lev::toCurrent(['page' => $page + 1]);
            }
            static::echoJson($msgs);
        }else {
            Lev::showMessages($msg);
        }
    }

    public static function actionReceive() {
        $body = json_decode(Requestv::getRawBody(), true);
        $pwd = Lev::stripTags(Lev::GPv('pwd'));

        $lists = $body['lists'];

        $msg = static::receiveData($lists, $pwd);

        static::echoJson($msg, 'application/json', null, JSON_UNESCAPED_UNICODE);
    }

    public static function actionPullServer() {
        $limit = intval(Lev::GPv('limit'));
        $pwd = Lev::stripTags(Lev::GPv('pwd'));
        if (!$pwd || $pwd !== static::receivePwd()) {
            $msg = Lev::responseMsg(-1, 'error pwd');
            static::echoJson($msg, 'application/json', null, JSON_UNESCAPED_UNICODE);
        }

        $obj = static::getDataModelObj();
        $limit = $limit <1 ? 1 : $limit;//数据过大会导致内存溢出而出错
        $lists = $obj::pages(1, $limit, ['id DESC']);
        $msg = Lev::responseMsg(1, '', ['lists'=>$lists]);
        static::echoJson($msg, 'application/json', null, JSON_UNESCAPED_UNICODE);
    }

    public static function receiveData($lists, $pwd, $pkey = 'id', $intval = 'strip') {
        $msg = Lev::responseMsg();
        $obj = static::getDataModelObj();
        if (is_array($lists) && $pwd && $pwd === static::receivePwd()) {
            $ids = Lev::getArrayColumn($lists, [$pkey], $intval);
            $cks = $obj::findAll([$pkey.' IN (\''.implode("','", $ids).'\')'], $pkey);
            foreach ($lists as $v) {
                if (!isset($cks[$v[$pkey]])) {
                    $msg[] = $obj::insert($v);
                }elseif (static::forceUpdate()) {
                    $msg['up'][] = $obj::update($v, [$pkey=>$v[$pkey]]);
                }
            }
        }
        return $msg;
    }

    public static function receivePwd()
    {
        return trim(Lev::stget('receivePwd', 'levs'));
    }

    public static function forceUpdate()
    {
        return intval(Lev::stget('forceUpdate', 'levs')) !== 1;
    }

    public static function pushSites()
    {
        return Lev::stget('pushSites', 'levs');
    }

    public static function headerHtm()
    {
        return '';
    }

}