<?php

namespace lev\ext;

use Lev;

class LevAC {
    // 阶乘
    public static function factorial($n) {
        return array_product(range(1, $n));
    }
    
    // 排列数
    public static function A($n, $m) {
        if ($n ==$m) return '1';
        return self::factorial($n)/self::factorial($n-$m);
    }
    public static function numA($param) {
        return self::A($param[0], $param[1]);
    }

    /**
     * 组合数
     * @param int $n
     * @param int $m
     * @param bool $isrepeat 为真时包含重复组合
     * @return float|int
     */
    public static function C($n, $m, $isrepeat = false) {
        if ($n ==$m) return 1;
        $isrepeat && $n += $m - 1;
        return self::A($n, $m)/self::factorial($m);
    }
    public static function numC($param) {
        return self::C($param[0], $param[1]);
    }
    
    // 排列
    public static function callLevA($array, $num, $flag = '', $returnArr = false) {
        return self::levA([$array, $num, $flag, $returnArr]);
    }
    public static function levA($param) {
        ini_set('memory_limit', '3256M');
        $a = $param[0];//数组
        $m = $param[1];//取出数量
        $f = $param[2] ? $param[2] : '';
        $s = $param[3];
        $carr = self::arrangement($a, $m);
        if ($s) return $carr;
        foreach ($carr as $v) {
            $res[] = implode($f, $v);
        }
        return $res;
    }
    public static function arrangement($a, $m) {
        $r = array();
        
        $n = count($a);
        if ($m <= 0 || $m > $n) {
            return $r;
        }
        
        for ($i=0; $i<$n; $i++) {
            $b = $a;
            $t = array_splice($b, $i, 1);
            if ($m == 1) {
                $r[] = $t;
            } else {
                $c = self::arrangement($b, $m-1);
                foreach ($c as $v) {
                    $r[] = array_merge($t, $v);
                }
            }
        }
        
        return $r;
    }
    
    // 带重复的组合。例：$param=array(array(1,2,3),2) 结果 11 12 13 22 23 33
    public static function callLevCs($array, $num, $flag = null, $returnArr = false) {
        //return self::levCs([$array, $num, $flag, $returnArr]);
        $flag = $returnArr ? null : $flag;
        return static::levCcs($array, $num, true, $flag);
    }
    public static function levCs($param) {
        ini_set('memory_limit', '3256M');
        $_a = $param[0];//数组
        $m = $param[1];//取出数量
        $f = $param[2] ? $param[2] : '';
        $s = $param[3];

        return static::levCcs($_a, $m);
    }
    
    // 组合 - 不重复
    public static function callLevC($array, $num, $flag = null, $returnArr = false) {
        //return self::levC([$array, $num, $flag, $returnArr]);
        $flag = $returnArr ? null : $flag;
        return static::levCcs($array, $num, false, $flag);
    }
    public static function levC($param) {
        ini_set('memory_limit', '3256M');
        $a = $param[0];//数组
        $m = $param[1];//取出数量
        $f = $param[2] ? $param[2] : '';
        $s = $param[3];
        $carr = self::combination($a, $m);
        if ($s) return $carr;
        foreach ($carr as $v) {
            $res[] = implode($f, $v);
        }
        return $res;
    }
    public static function combination($a, $m) {
        $r = array();
        
        $n = count($a);
        if ($m <= 0 || $m > $n) {
            return $r;
        }
        
        for ($i=0; $i<$n; $i++) {
            $t = array($a[$i]);
            if ($m == 1) {
                $r[] = $t;
            } else {
                $b = array_slice($a, $i+1);
                $c = self::combination($b, $m-1);
                foreach ($c as $v) {
                    $r[] = array_merge($t, $v);
                }
            }
        }
        
        return $r;
    }

    //多个数组排列。$d = array(array(1,2),array(3,4), ...);
    public static function fors($d) {
        ini_set('memory_limit', '3256M');
        //计算每一个数组的长度
        $len = 1;
        $arrLen = count($d); //需要排列数组有多少个
        $recIndex = null; //记录当前该取的位置
        //foreach 计数
        $count_3 = 0;
        foreach ($d as $key => $value) {
            $lenRec[$count_3] = count($value);
            $len = $lenRec[$count_3]*$len;
            $recIndex[] = 0;//第一次全部取第0个
            $count_3++;
        }
        //算出% 的值
        $count = 1;
        foreach ($lenRec as $key => $value) {
            $moduloVal = 1;
            
            if($arrLen == $count){
                $modulo[] = count($d[$arrLen-1]); //等于最后一个的长度
            }else{
                $count_1 = 1;
                foreach ($lenRec as $index => $item) {
                    $count_1 > $count && $moduloVal = $moduloVal*$item;
                    $count_1 ++;
                }
                $modulo[] = $moduloVal;
            }
            $count ++;//为了防止$d key是有值的 不是自然序列 需要计数
        }
        $i = 1;

        while ( $i <= $len) {
            $zh = array();
            $count_2 = 0;// 取模
            foreach ($d as $value) {
                $dkey = $recIndex[$count_2]%$lenRec[$count_2];
                $zh[] = $value[$dkey];
                $count_2 ++;
            }
            $zharr[] = $zh;
            foreach ($modulo as $key => $value) {
                if($i%$value == 0 && $key < $arrLen - 1 ){
                    $recIndex[$key] = $recIndex[$key] +1;
                }
                if($key == $arrLen - 1){
                    if($i%$value == 0){
                        $recIndex[$key] = 0;
                    }else{
                        $recIndex[$key] = $recIndex[$key] +1;
                    }
                }
            }
            $i ++;//改变获取的位置
        }

        return $zharr;
    }


    /**
     * 多数组生成组合 - 内存够用可达百万级数量
     * @param $arrs
     * @param $nums
     * @param bool $isrepeat
     * @param string $flag
     * @return array
     */
    public static function levCcses($arrs, $nums, $isrepeat = false, $flag = ',') {

        static::$levCcsesRecursionResult = [];

        $combs = []; $total = 1; $k = -1;
        foreach ($arrs as $key => $v) { $k++;
            $combs[$k] = static::levCcs($arrs[$key], ($nums[$key]?$nums[$key]:$nums), $isrepeat, $flag);
            $total *= count($combs[$k]);
        }

        if ($total >3000000) {
            return Lev::responseMsg(-1, '生成数量过大【'.$total.'】被中止');
        }

        static::levCcsesRecursion($combs[0], '', $combs, 0);

        return static::$levCcsesRecursionResult;
    }
    public static $levCcsesRecursionResult = [];//多数组组合结果
    public static function levCcsesRecursion($arr, $_one, $recArrs, $k) {
        foreach ($arr as $v) {
            $one = $_one;
            $one .= $v.',';
            if (isset($recArrs[$k+1])) {
                static::levCcsesRecursion($recArrs[$k+1], $one, $recArrs, $k+1);
            }else {
                static::$levCcsesRecursionResult[] = trim($one, ',');
            }
        }
    }

    /**
     * 单数组生成组合 - 内存够用可达百万级数量
     * @param $arr
     * @param int $num
     * @param bool $isrepeat = false 返回不重复组合
     * @param string $flag = null 返回数组
     * @return array
     */
    public static $recursionArrayResult = [];//组合结果
    public static function levCcs($arr, $num = 1, $isrepeat = true, $flag = ',') {
        $total = static::C(count($arr), $num, true);
        if ($total >3000000) {
            return Lev::responseMsg(-10011, '生成数量过大【'.$total.'】被中止');
        }

        ini_set('memory_limit', '3256M');

        static::$recursionArrayResult = [];

        $arr = array_values($arr);
        foreach ($arr as $k => $v)  {
            $one = $flag === null ? [$v] : $v.$flag;
            if ($num >1) {
                $isrepeat ? static::recursionArrays($arr, $k, $one, $num-2, $flag) : static::recursionArray($arr, $k, $one, $num-2, $flag);
            }else {
                static::$recursionArrayResult[] = $one;
            }
        }
        return static::$recursionArrayResult;
    }
    //嵌套循环 - 重复
    private static function recursionArrays($arr, $k, $one, $num, $flag) {
        foreach ($arr as $k1 => $v1) {
            if ($k1 > $k) break;
            if ($num >0) {
                $_one = $one;
                if ($flag === null) {
                    $_one[] = $v1;
                }else {
                    $_one .= $v1.$flag;
                }
                static::recursionArrays($arr, $k1, $_one, $num-1, $flag);
            }else {
                $_one = $one;
                if ($flag === null) {
                    $_one[] = $v1;
                }else {
                    $_one .= $v1;
                }
                static::$recursionArrayResult[] = $_one;
            }
        }
    }
    //嵌套循环 - 非重复
    private static function recursionArray($arr, $k, $one, $num, $flag) {
        foreach ($arr as $k1 => $v1) {
            if ($k1 >= $k) break;
            if ($num >0) {
                $_one = $one;
                if ($flag === null) {
                    $_one[] = $v1;
                }else {
                    $_one .= $v1.$flag;
                }
                static::recursionArray($arr, $k1, $_one, $num-1, $flag);
            }else {
                $_one = $one;
                if ($flag === null) {
                    $_one[] = $v1;
                }else {
                    $_one .= $v1;
                }
                static::$recursionArrayResult[] = $_one;
            }
        }
    }

}









