<?php
/**
 * Copyright (c) 2022-2222   All rights reserved.
 *
 * 创建时间：2022-11-15 23:01
 *
 * 项目：levs  -  $  - index.php
 *
 * 作者：liwei
 */

//!defined('INLEV') && exit('Access Denied LEV');

//此文件使用程序自动生成，下次生成时会覆盖，不建议修改。
echo \lev\base\Assetsv::animateCss(true);
?>

<div class="page page-levs-receive-push">
    <div class="navbar navbar-bgcolor-red">
        <div class="navbar-inner">
            <div class="left"></div>
            <div class="title">数据推送</div>
            <div class="right"></div>
        </div>
    </div>

    <div class="page-content">
        <div class="page-content-inner wdx660">
            <?php isset($headerHtm) ? (is_file($headerHtm) ? include $headerHtm : print_r($headerHtm)) : print_r('')?>

            <div class="card data-xtable">
                <table>
                    <tr>
                        <th><input type="checkbox" name="opids" onclick="checkedToggle(this,'input[name=\'idsvv[]\']')"></th>
                        <th>站点名称</th>
                        <th>推送域名</th>
                    </tr>
                    <?php foreach ($pushSites as $v) {?>
                    <tr>
                        <td><input type="checkbox" name="idsvv[]" value="<?=$v['id']?>"></td>
                        <td><?=$v['name']?></td>
                        <td>
                            <a target="_blank" _bk="1" href="<?=$v['domain'],$domainurl?>">
                                <svg class="icon"><use xlink:href="#fa-huoj"></use></svg>
                                <?=$v['domain']?>
                            </a>
                        </td>
                    </tr>
                    <?php }?>
                </table>
                <div class="card-footer">
                    <div class="font12 transl">
                        勾选站点推送或下载设置：每页
                        <input type="text" class="wd40 tab-center inblk pageLimit" value="32"> 条，
                        共执行
                        <input type="text" class="wd40 tab-center inblk pageNum" value="1"> 页，
                    </div>
                    <label class="scale9">
                        <input type="checkbox" value="1" class="onlySelectIds">仅选中
                    </label>
                </div>
            </div>
            <div class="card card-header">
                <div class="buttons-row scale9">
                <a class="button-fill button button-small color-black pushDatasBtn" href="<?=$pushUrl?>">推送数据</a>
                <a class="button-fill button button-small color-blackg pullDatasBtn" href="<?=$pullUrl?>">下载数据</a>
                </div>
                <div class="buttons-row scale9">
                <a class="button-fill button button-small color-black openPP" href="<?=$setUrl?>">站点设置</a>
                </div>
            </div>
            <ol class="ol-cm">
                <li><tips>[推送数据]说明：将本站点的数据推送到【推送设置】中设置的站点</tips></li>
                <li><tips>[下载数据]说明：从【推送设置】中设置的站点下载数据到本站，仅限正常状态下的站点，成功获得数据后中断</tips></li>
                <li><?=$tips?></li>
            </ol>
            <ol class="ol-cm tipsbox"></ol>
        </div>
    </div>

    <div class="LoadPageAjaxJS">
        <script>
            jQuery(function () {
                Levme.onClick('.pushDatasBtn', function () {
                    var href = jQuery(this).attr('href');
                    showTips('开始推送：');
                    pushData(href);
                    return false;
                });
                Levme.onClick('.pullDatasBtn', function () {
                    var href = jQuery(this).attr('href');
                    showTips('开始下载：');
                    pushData(href);
                    return false;
                });

                function pushData(url) {
                    var limit = parseInt(jQuery('.pageLimit').val()) || 0;
                    var pageNum = parseInt(jQuery('.pageNum').val()) || 0;
                    var pushType = jQuery('.onlySelectIds:checked').length <1 ? 0 : 1;
                    var pushIds = [];
                    if (pushType) {
                        pushIds = getCheckids();
                        if (pushIds.length < 1) {
                            Levme.animated('.data-xtable.gen-tab input[name="ids[]"]');
                            return levtoast('您至少选中一项数据项');
                        }
                    }
                    var doids = [];
                    jQuery('input[name="idsvv[]"]:checked').each(function () {
                        doids.push(this.value);
                    });
                    if (doids.length < 1) {
                        Levme.animated('input[name="idsvv[]"]');
                        levtoast('您至少选中一项');
                        return ;
                    }
                    Levme.ajaxv.getv(url, function (data, status) {
                        if (data.nextUrl) {
                            Levme.setTimeout(function () {
                                pushData(data.nextUrl);
                            }, 1000);
                        }
                        if (data.pushRes) {
                            var pushRes = '';
                            for (var k in data.pushRes) {
                                pushRes += '<li>'+k+ ' => ' +data.pushRes[k]+'</li>';
                            }
                            showTips(pushRes);
                        }
                    }, {limit:limit,pageNum:pageNum, doids:doids, pushids:pushIds});
                }

                function showTips(tip) {
                    if (tip && tip.indexOf('<li') !== 0) {
                        tip = '<li>'+ tip +'</li>';
                    }
                    jQuery('ol.tipsbox').append(tip);
                }
                function getCheckids() {
                    var idsArr = [];
                    jQuery('.data-xtable.gen-tab input[name="ids[]"]:checked').each(function () {
                        idsArr.push(this.value);
                    });
                    return idsArr;
                }
            });
        </script>
    </div>
</div>
