<?php
/**
 * Copyright (c) 2022-2222   All rights reserved.
 *
 * 创建时间：2022-04-03 23:46
 *
 * 项目：levs  -  $  - tabViewZstxtWdiget.php
 *
 * 作者：liwei
 */

//!defined('INLEV') && exit('Access Denied LEV');


namespace modules\levs\widgets\admin_quick_nav;

use Lev;
use lev\base\Assetsv;
use lev\base\Controllerv;
use lev\helpers\ModulesHelper;
use lev\widgets\adminModulesNav\adminModulesNav;
use lev\widgets\tab_view\tabViewWidget;

class tabViewAdminQuickNavWidget extends tabViewWidget
{
    public static $tabnav = [];

    public static $param = [
        'subnavHide'  => '',//hiddenx
        'paddingTop'  => 'padding:70px 0 0;',
        'pageFile'    => '',
        'footer'      => '',
        'toolbar'     => '',
        'navbarInner' => '',
        'tabViewName' => 'levsTabViewAdminQuickNav',
        //'noCache'     => 0,//每次打开popup弹窗是否强制刷新 暂未实现此功能
        'infiniteInit'=> 1,//无限加载，自动初始化。1：自动，0：手动
    ];

    /**
     * 直接显示 模板文件 由控制器直接调用即可
     * @param string $deTabId
     * @param bool $renders
     * @see AdminQuickNavController::actionIndex()
     */
    public static function viewvs($deTabId = 'default', $renders = true, $assets = '')
    {
        !$deTabId && $deTabId = 'default3';

        $navbarTitle = '快捷导航';
        static::setParam('navbarTitle', $navbarTitle);
        static::setParam('pageName', Controllerv::$pageName.'_'.str_replace('.', '', microtime(true)));//根据参数，使弹窗数据加载唯一
        static::setParam('footer', __DIR__ . '/views/footer.php');
        static::setParam('toolbar', __DIR__ . '/views/toolbar.php');
        static::setParam('pageFile', __DIR__ . '/views/pages/swipes/swipe.php');//static::swipesFile()
        static::setParam('navbarInner', __DIR__ . '/views/navbar_inner.php');
//        static::setParam('navbarInner', [//__DIR__ . '/views/navbar_inner.php'设置一个php文件路径自定义导航; 设置null调用全局头部导航
//            'srh' => [
//                'placeholder' => '【xxx】搜索'
//            ]
//        ]);

        Lev::$app['title'] = $navbarTitle;
        static::setDeTabId($deTabId);
        Lev::$app['title'] .= ' '.Lev::arrv([static::$deTabId, 'name'], static::getTabnav());

        $assets = static::assetsAll();

        parent::viewvs($deTabId, $renders, $assets); // TODO: Change the autogenerated stub
    }

    public static function assetsAll()
    {
        static $assets;
        if (!isset($assets)) {
            $assets = '';//Assetsv::registerAppMud('levs', levsHelper::$mud['version']);//需要自行引入相关类
        }
        return $assets;
    }

    /**
     * 统一消息提示
     * @param int $status
     * @param null $message
     * @param array $ext
     * @param bool $translation
     * @return array
     */
    public static function responseMsg($status = 1, $message = null, $ext = [], $translation = true) {
        $ext += ['htms'=>'', 'not'=>1];
        return Lev::responseMsg($status, $message, $ext, $translation);
    }

    /**
     * 配置每个滑块标签页面
     * @return array
     */
    public static function getTabnav()
    {
        if (!static::$tabnav) {
//            static::setTabnav('default3', '标签3', 2, static::loadRoute('default3'), '', '', [
//                'force' => 0,//不缓存数据，强制更新
//                'loadStartTip' => '点击加载更多',
//                'pageContents' => '',//messages-content 添加到.page-content css类中
//                'toolbar' => '',
//                'footer' => __DIR__ . '/views/tab/footer.php',//它可以是一个字符串，也可以是一个php文件路径
//                'tabWidth' => '660px',
//                //'extPm' => ['sx' => 1],
//            ]);
            static::setTabnav('quicknav', '快捷导航', 2, static::loadRoute('quicknav'), '', '', [
                'force' => 0,//不缓存数据，强制更新
                'loadStartTip' => '',
                'pageContents' => '',//messages-content 添加到.page-content css类中
                'toolbar' => '',
                'footer' => __DIR__ . '/views/tab/footer.php',//它可以是一个字符串，也可以是一个php文件路径
                'tabWidth' => '660px',
                //'extPm' => ['sx' => 1],
            ]);
        }
        return parent::getTabnav(); // TODO: Change the autogenerated stub
    }

    /**
     * 标签自动加载数据路由
     * @param $tab
     * @return bool|mixed|string
     * @see AdminQuickNavController::actionLoadData()
     */
    public static function loadRoute($tab) {
        //return Lev::toReRoute(['admin-quick-nav/load-data', 'tab' => $tab, 'id'=>'levs']);
        $pm = ['admin-quick-nav/load-data', 'tab' => $tab, 'id'=>'levs'];
        if (1 || $tab == static::$deTabId) {
            $pm['r'] = $pm[0];
            unset($pm[0], $pm['_'], $_GET['_'], $_GET['_csrf']);
            return Lev::toCurrent($pm, true, false);
        }
        return Lev::toReRoute($pm);
    }

    /**
     * 标签自动加载数据源
     * @param string $tab
     * @return array
     * @see AdminQuickNavController::actionLoadData()
     */
    public static function loadData($tab = 'default') {
        if (method_exists(__CLASS__, $method = 'tab'.ucfirst($tab))) {
            return static::$method();
        }
        $limit = 25;
        $lists = [];
        $htms = parent::render(0, __DIR__ . '/views/load_data.php', [
            'tab' => $tab,
        ]);
        return static::responseMsg(1, '', ['htms'=>$htms, 'not'=>count($lists) < $limit ? 1 : 0, 'maxPage'=>100]);
    }

    /**
     * 标签自动加载数据源 - default3 标签
     * @return array
     * @see tabViewAdminQuickNavWidget::loadData()
     */
    public static function tabDefault3() {
        $modules = ModulesHelper::findAll(1);
        $htms = parent::render(0, __DIR__ . '/views/tab/default3.php', [
            'tab' => 'tabDefault3',
            'modules' => $modules,
        ]);
        return static::responseMsg(1, '', ['htms'=>$htms, 'not'=>1, 'maxPage'=>100]);//maxPage > 100 自动删除首页
    }


    public static function tabQuicknav() {
        $htms = parent::render(0, __DIR__ . '/views/tab/quicknav.php', [
            'quicknav' => adminModulesNav::getQuickNav(),
        ]);
        return static::responseMsg(1, '', ['htms'=>$htms, 'not'=>1, 'maxPage'=>100]);//maxPage > 100 自动删除首页
    }
}